use warnings;
use strict;

use DBD::SQLite;
use Carp;
my $dbh;

print "db gi esistente" and exit if -e "flashServe.sqlite";

# Crea Db:
$dbh = DBI->connect("dbi:SQLite:flashServe.sqlite", "", "",
  		{RaiseError => 1, AutoCommit => 1})
or croak "ERROR: Can't connect to sqlite database: " . DBI->errstr;
    
# Tabella mos_users:
$dbh->do("CREATE TABLE mos_users
    	( username PRIMARY KEY UNIQUE, password , block )" )		
      	or croak "ERROR: " . $dbh->errstr;

# Crea alcuni utenti di prova:
creaUtente(username => "mada", password => "mada", block => 1);

print "Db Creato con successo";
exit 0;


sub creaUtente {
    my (%args) = @_;

    my $sth = $dbh->prepare( qq{
        INSERT INTO mos_users ( username, password, block )
               VALUES (?, ?, ?)
    }) or croak "Error: can't insert into database: " . $dbh->errstr;

    $sth->execute( @args{ qw( username password block ) } )
      or croak "Error: can't insert into database: " . $dbh->errstr;

    return $dbh->func('last_insert_rowid');
}