#!/usr/bin/perl -w

# This program is a simple chat server.  It allows multiple people to
# connect and exchange messages.  It's a very simple example, but it
# can be the base of many multiuser things.
#

use warnings;
use strict;

#$/ = "\0";
use Time::HiRes;
use POE;
use POE::Component::Server::TCP;
use POE::Filter::Stream;
use POE::Component::DBIAgent;
use Digest::MD5 qw(md5 md5_hex md5_base64);

my $max_canali_per_user = 3;

my %users;
my %nicks;
my %canali;
my $DBSession;

my $prova = md5_hex("cacabam");
# Create the server on port 7777, and start it running.
#system("echo server started $prova");

POE::Component::Server::TCP->new
  ( Alias => "chat_server",
    Port               => 7777,
    InlineStates       => { send => \&handle_send, user_autorizzazione =>\&user_autorizzazione, user_anonimo_autorizzazione =>\&user_anonimo_autorizzazione },
    ClientConnected    => \&client_connected,
    ClientError        => \&client_error,
    ClientDisconnected => \&client_disconnected,
    ClientInput        => \&client_input,
    #ClientFilter       => [ "POE::Filter::Stream" ],
    ClientFilter       => [ "POE::Filter::Line", Literal => "\0"],
  );

POE::Session->create
  ( inline_states => { _start => \&start_db_process,
			},
  );


select STDERR;
print "Running flashServe...\n";
$poe_kernel->run();
exit 0;

sub start_db_process {

	my ($self, $kernel, $heap) = @_[OBJECT, KERNEL, HEAP];

	#my $dsn = 'DBI:mysql:database=mambodb;host=192.168.0.111;port=3306';
	my $dsn = "DBI:SQLite:flashServe.sqlite";
	my $username = '';
	my $password = '';
	my %hash = {RaiseError => 1, AutoCommit => 1};


	$heap->{helperdb} = POE::Component::DBIAgent->new(
		DSN => [$dsn, $username, $password],
		Queries => {
				login => "select block from mos_users where username = ? AND password = ?",
				login_anonimo => "select username from mos_users where username = ? ",
			},
		Count => 3,
		Debug => 1,

	);

	$DBSession = $_[SESSION];

}

sub user_start {
	#my $session_id = $_[SESSION]->ID;
	#$_[KERNEL]->alias_set("$session_id");
	#system("echo partito");

}

# This is a plain Perl function (not a POE event handler) that
# broadcasts a message to all the users in the chat room.  The %users
# hash is used to track connected people.

sub broadcast {
    my ( $sender, $message ) = @_;
    foreach my $user ( keys %users ) {
        &direct_send( $user, "$message" );
    }
}

# Handle an outgoing message by sending it to the client.

sub handle_send {
    my ( $heap, $message ) = @_[ HEAP, ARG0 ];
    $heap->{client}->put("$message") if defined $heap->{client};
}


## Mette direttamente il messaggio nella coda dell'utente:
sub direct_send {
	my ($session_id, $message) = @_;
	#my $myHeap = $poe_kernel->ID_id_to_session($session_id)->get_heap();

	## credo non possa andare cosi:
	## Piu veloce:
	#$myHeap->{client}->put("$message");

	## Vecchio metodo:
	if(!defined $message || !defined $session_id) { return ; }
	print STDERR "s $session_id-> $message \n";
	$poe_kernel->post( $session_id => send => $message );

#	my $session = $poe_kernel->get_active_session();
#	$poe_kernel->post($session->ID => send => $message);

}

## manda a tutta la stanza
sub send_to_room_noecho {
	##TODO:flood control, spostare il thread dalla session del destinatario a quella del mittente?
	##TODO: valutare cosa mettere in uno stato separato
	my ($session_id, $chan, $message) = @_;

	#my $nick = $users{$session_id};
	print STDERR "$chan -> $message \n";
	foreach my $user_session_id ( keys( %{$canali{$chan}->{nicks}} ) ) {
        	if( $session_id != $user_session_id ) { &direct_send( $user_session_id, "$message" ); }
    }
}

## manda a tutta la stanza e a se stessi
sub send_to_room {
	##TODO:flood control, spostare il thread dalla session del destinatario a quella del mittente?
	##TODO: valutare cosa mettere in uno stato separato
	my ($session_id, $chan, $message) = @_;

	#my $nick = $users{$session_id};
	print STDERR "$chan -> $message \n";
	foreach my $user_session_id ( keys( %{$canali{$chan}->{nicks}} ) ) {
        	&direct_send( $user_session_id, "$message" );
    }
}

## manda al nick specificato:
sub send_to_nick {
	my ($session_id, $nick, $message) = @_;
	print STDERR "$nick -> $message \n";
	&direct_send($nicks{$nick}, "$message" );
}

sub send_to_session {
	my ($session_id, $to_session, $message) = @_;
	print STDERR "$to_session -> $message \n";
	&direct_send($to_session, "$message" );
}

sub send_to_me {
	my ($session_id, $message) = @_;
	print STDERR "$session_id -> $message \n";
	&direct_send($session_id, "$message" );
}

sub client_connected {
    my $session_id = $_[SESSION]->ID;
    $users{$session_id} = 1;
    #broadcast( $session_id, "connected" );


}

## rimuove gli utenti dalle stanze e diche che sono quittati, cancella ogni ref dell'utente.
sub client_disconnected {

    my $session = $poe_kernel->get_active_session();
    my $session_id = $session->ID;
    print STDERR "DISCONNECT: $session_id\n";

    ## questa f viene chiamata due volte: quando quitta esegue dei "post" che "rianimano" la session,
    ## al termine dei quali viene riinvocato client_disconnected. non dovrebbe creare problemi.
    if( defined $users{$session_id} and not $users{$session_id} == 1  ) {
    	#print "ENTRATO: $session_id\n";
		my $nick = $users{$session_id};
		#system("echo canali: " . $nicks{$nick}->{canali}->{ciao} . " $nick $session_id");

		foreach my $chan ( keys( %{ $nicks{$nick}->{canali} } ) ) {
			&room_exit($session, $chan, 1);
		}

		## cancella tutte le ref all'utente:
		delete $nicks{$nick};
		delete $users{$session_id};
    }

    #system("echo A vuoto $session_id");
}

# The client socket has had an error.  Remove them from the chat room
# and broadcast a message to whoever is left.

sub client_error {
	my $session = $poe_kernel->get_active_session();
   	my $session_id = $session->ID;
	print STDERR "ERRORE: $session_id\n";

	## pare che chiami comunque disconnect...
	&client_disconnected();
	##TODO:loggare gli errori, statistiche ecc


	#$_[KERNEL]->yield("shutdown");

}


sub inserisci_utente {
	my($nick, $session_id, $myHeap) = @_;

	#system("echo ok");
	#system("echo nick $nick session $session_id");

	##controlla che non sia gi in uso:
	##	devo farlo qua perch le chiamate sono asincrone
	foreach my $user ( keys %users ) {
		if ( $users{$user} =~ /^${nick}$/i ) {
			&direct_send($session_id , "/nickinuse" );
			return 0;
		}
	}

	## imposta nick:
	$users{$session_id} = $nick;
	$nicks{$nick}->{session} = $session_id;

	#&broadcast( $session_id, "/connected $nick" );
	&direct_send( $session_id, "/connected" );

}

sub user_autorizzazione {
    my ($query, $parametri) = @_[ARG0, ARG1];
    #$query = shift(@$query);
    my ($session_id, $nick)= ($parametri->{session_id}, $parametri->{nick});
    #my $session = $_[SESSION];
    my $myHeap = $poe_kernel->get_active_session()->get_heap();


    #system("echo registrato $session_id");
    if ( $query ne 'EOF' ) {
    	#system("echo nick $nick session $session_id");

	#system("echo auth '@$query ' \n");
	if( "@$query[0]" eq 0 ) {

		&inserisci_utente($nick, $session_id, $myHeap);

		$myHeap->{conta_login} = 1;
	};
    }
    else {
	#system("echo EOF");
	if($myHeap->{conta_login} != 1) {
		&direct_send($session_id, "/badlogin" );
	};
    };

}

sub user_anonimo_autorizzazione {
    my ($query, $parametri) = @_[ARG0, ARG1];

    my ($session_id, $nick)= ($parametri->{session_id}, $parametri->{nick});


    my $myHeap = $poe_kernel->get_active_session()->get_heap();

#     system("echo anonimo $nick");
    if ( $query ne 'EOF' ) {
    	#system("echo nick $nick session $session_id");

# 	system("echo nick registrato inserire la password \n");
	&direct_send( $session_id, "/badnick" );
	$myHeap->{conta_anonim} = 1;

    }
    else {
    #se  il primo comando ricevuto fallo entrare:
    	if( (!defined $myHeap->{conta_anonim}) || ($myHeap->{conta_anonim} != 1) ) {

		&inserisci_utente($nick, $session_id, $myHeap);
		#$myHeap->{conta_anonim} = 0;
	}
	else {
		$myHeap->{conta_anonim} = 0;

	};

# 	system("echo EOF");
    };

}

sub logIn {
	my ($session, $nick) = @_;
	##TODO: controllare i caratteri validi per la pass:
	my $password;
	my $MyHeap;
	my $session_id = $session->ID;
	##valido:
	#unless ($stringa =~ m#(.[][{}|\w^]{2,20})#) { return 0; }


	if ($nick =~ m#^([][{}|\w^]{2,20}) ([][{}|\w^]{2,20})#) {
		$nick = $1;
		$password = $2;
		#system("echo nick $1 pass $2");
		##manda il controllo al processo DB
		$MyHeap = $DBSession->get_heap();

		my %passa = (
			session_id => $session_id,
			nick => $nick,
		);

		$MyHeap->{helperdb}->query( login =>
		{ cookie => \%passa, delay => undef } =>
		$session_id =>
		"user_autorizzazione" =>
		($nick, md5_hex($password) )
		);

	}
	elsif ($nick =~  m#^([][{}|\w^]{2,20})#) {
		#TODO: case insensitive nella query: (ma non sono sicuro serva)
		#fa un altra query che cerca solo username
		#fregandoseene di password
		#poi user_anonimo_autorizzazione vede se il nick
		#non registrato  in uso, allora telo da
		$nick = $1;

		#system("echo nick $1 pass $2");
		##manda il controllo al processo DB
		$MyHeap = $DBSession->get_heap();

		my %passa = (
			session_id => $session_id,
			nick => $nick,
		);

		$MyHeap->{helperdb}->query( login_anonimo =>
		{ cookie => \%passa, delay => undef } =>
		$session_id =>
		"user_anonimo_autorizzazione" =>
		( $nick )
		);

		##o piu semplicemente: (mi risparmio una query...  da valutare)
		#&inserisci_utente("Anon$session_id", $session_id, $MyHeap);
		#$poe_kernel->post( $session_id => send => "/anonimousnick Anon$session_id" );
	}
	else {
		&direct_send( $session_id, "/badnick" );
	}

}

sub room_enter {
	##usare liste o hash? con le hash se vorro aggiungere parametri lo posso fare
	##TODO: togliere /master e /slave dalle chatroom (fare un altro server per le chat&lobby?)
	my ($session, $chan, $limit, $game) = @_;

	my $session_id = $session->ID;
	my $nick = $users{$session_id};

	##  gi nel canale:
	if (defined $nicks{$nick}->{canali}->{$chan}) {
		return 0;
	}

	## il canale  pieno:
	if ( (defined $canali{$chan}) && ($canali{$chan}->{limit} != 0) && ($canali{$chan}->{people_number} >= $canali{$chan}->{limit}) ) {
		 &direct_send($session_id, "/toomanyusers");
		 return 0;
	}

	## il canale esiste gi quindi non pu essere specificato un limite:
	if (defined $canali{$chan}) { $limit = $canali{$chan}->{limit}; }

	## vuole entrare in un gioco:
	if ( defined $game ) {

		## ma non  una gameroom:
		if( (defined $canali{$chan}) && (!defined $canali{$chan}->{gameroom}) ) {
			&direct_send( $session_id, "/badgameroom" );
			return 0;

		}

		## si pu stare in una sola stanza di gioco alla volta:
		if (defined $nicks{$nick}->{gameroom}) {
			&room_exit($session, $nicks{$nick}->{gameroom});
		}

		## aggiunge il canale nella lista dell'utente come gameroom(1)
		$nicks{$nick}->{canali}->{$chan} = 1;
		$nicks{$nick}->{gameroom} = $chan;

		##se  stata appena creata:
		if(!defined $canali{$chan}) {
			## in futuro il numero distinguer i vari giochi
			my $gameType = 1;
			## avverte gli altri:
			&broadcast($session_id, "/gamecreated $chan $gameType $limit");

			## mette come tipo alla chat gameroom:
			$canali{$chan}->{gameroom} = $gameType;
		}

	}
	else {
	## vuole entrare in una chat:

		## ma  una gameroom:
		if (defined $canali{$chan}->{gameroom}) {
			## non  una chat ma una gameroom:
			&direct_send( $session_id, "/badchan" );
			return 0;
		}

		## si pu stare in max_canali_per_user canali alla volta:
		my $num = keys( %{ $nicks{$nick}->{canali}} );
		if ($num > $max_canali_per_user ) {

			&direct_send($session_id, "/toomanychannels $max_canali_per_user" );
			return 0;
		}

		## aggiunge il canale nella lista dell'utente come chat(0)
		$nicks{$nick}->{canali}->{$chan} = 0;
	}

	## inserisce l'utente nella chat:
	$canali{$chan}->{nicks}->{$session_id} = $nick;

	## aggiorna il numero di persone nella chat:
	if(defined $canali{$chan}->{people_number}) {
		$canali{$chan}->{people_number}++;
	} else {
		$canali{$chan}->{people_number} = 1;
	}

	## inserisce il numero max di giocatori:
	$canali{$chan}->{limit} = $limit;

	## Segnala le informazioni sul chan:
	my $info;
	if (defined $canali{$chan}->{gameroom}) {
		$info = $canali{$chan}->{gameroom};
	}
	else {
		$info = "0";
	}
	&direct_send($session_id, "/chaninfo $chan l:$canali{$chan}->{limit} t:$info");

	## se non c' un master eleggi il nuovo utente
	if(defined $canali{$chan}->{gameroom}) {
		if (!defined $canali{$chan}->{master}) {
			$canali{$chan}->{master} = $session_id;
			&send_to_session($session_id, $session_id, "/master" );
		}
		else {
			&send_to_session($session_id, $session_id, "/slave" );
		}
	}

	## avvisa gli altri:
	&send_to_room_noecho($session_id, $chan, "/join $chan $nick");

	##TODO per compatibilit (rimuovere quanto prima):
#	foreach my $forsession (keys %{ $canali{$chan}->{nicks} }) {
# 		if ($forsession != $session_id) {
#			&direct_send($session_id, "/join $chan $users{$forsession}" );
#		}
#	}

	## comunica la namelist al nuovo entrato:
 	my $namelist = "/namelist $chan";
 	foreach my $fornick (keys %{ $canali{$chan}->{nicks} }) {
 		$namelist = $namelist . " $users{$fornick}";
	}

	&direct_send( $session_id, $namelist );
}

sub room_exit {
	##Fa uscire un utente dalla stanza:
	my ($session, $chan, $quit) = @_;

	my $session_id = $session->ID;
	my $nick = $users{$session_id};

	## l'utente non  in questa chat:
	if (!defined $nicks{$nick}->{canali}->{$chan}) {
		return 0;
	}

	## rimuove la chat dalla lista dell'utente
	delete $nicks{$nick}->{canali}->{$chan};

	##  se  una gameroom:
	if ( (defined $nicks{$nick}->{gameroom}) && ($nicks{$nick}->{gameroom} eq $chan) ) {

		## toglie la gameroom dalla lista dell'utente:
		delete $nicks{$nick}->{gameroom};

	}

	## se ci sono ancora persone:
	if ($canali{$chan}->{people_number} > 1) {
		##rimuove l'utente
		delete $canali{$chan}->{nicks}->{$session_id};

		## decrementa il numero di persone presenti nel canale:
		$canali{$chan}->{people_number}--;

		##se era un master eleggine un altro:
		##TODO: per adesso lascia libero il trono, lo prende chi entra subito dopo
		if ((defined $canali{$chan}->{master}) && ($canali{$chan}->{master} eq $session_id) ) {
			delete $canali{$chan}->{master};
		}

		## se  un quit:
		if(defined $quit) {
			&send_to_room($session_id, $chan, "/quit $chan $nick");
		}
		else {
		## se  un part:
			## non so se fare l'echo locale o remoto:
			##TODO: (come in FSServe.as) questa cosa non mi piace
			&send_to_room($session_id, $chan, "/part $chan $nick");
		};
	}
	else {
	##la stanza  vuota:
		## cancella la stanza:
		delete $canali{$chan};

		## avverte li altri della distruzione:
		&broadcast($session_id, "/gameremoved $chan");
	};
}

## manda la lista delle gameroom aperte e _libere_
## SINTASSI: /listagame (<nome gameroom> <numero utenti> <limite utenti>)*
## TODO: valutare se mandare anche le altre e altre info
## TODO: valutare se bloccare i messaggi di creazione/distruzione di una room mentre uno gioca
sub room_listgame {
	my ($session) = @_;

	my $session_id = $session->ID;

	my $list = "/listgames ";

	## se un canale  di tipo gameroom aggiungilo alla lista:
	foreach my $chan (keys %canali) {
		if(defined $canali{$chan}->{gameroom}) {
			$list = $list . "$chan 1 " . $canali{$chan}->{limit} . " " . $canali{$chan}->{people_number} . " ";
		}
	}

	&direct_send( $session_id, $list );
}

############ MANAGE USER INPUT: ###############

sub client_input {
    #$/ = "\0";
    my ( $kernel, $session, $heap, $input ) = @_[ KERNEL, SESSION, HEAP, ARG0 ];
    my $session_id = $session->ID;

    if (length($input) < 1) {
    	return 1;
    }
    else {
    	print STDERR $input . "\n";
    	## LOG IN:
	if( "$users{$session_id}" eq "1" ) {
		#se deve ancora fare il login:
		if( $input =~ m#^/nick (.+)# ) {
			&logIn($session, $1);
		}
	}
    else {
		if( substr($input, 0 ,1) eq '/' ) {
			## messaggio di sistema:
			#if($input =~ m#/nick (.[][{}|\w^]{2,15})#) {
			if( $input =~ m#^/nick (.+)# ) {
				#cambiaNick($1, $session);
			}
			elsif ( $input =~ m#^/joingame (\S{2,15}) (\d{1,3})# ) {
				## sessione, canale, limite, gameroom
				&room_enter($session, $1, $2, 1);

			}
			elsif ( $input =~ m#^/joingame (\S{2,15})# ) {
				## sessione, canale, no limite, gameroom
				&room_enter($session, $1, 0, 1);

			}
			elsif ( $input =~ m#^/join (\S{2,15}) (\d{1,3})# ) {
				## sessione, canale, limite, no gameroom
				&room_enter($session, $1, $2);

			}
			elsif ( $input =~ m#^/join (\S{2,15})# ) {
				## sessione, canale, no limite, no gameroom
				&room_enter($session, $1, 0);
			}
			elsif ( $input =~ m#^/part (\S{2,15})# ) {
				&room_exit( $session, $1);

			}
			elsif ( $input =~ m#^/listgames# ) {
				&room_listgame($session);

			}
			else {
				&send_to_me( $session_id ,"/unknowncommand" );
			}

		}
		elsif ( substr($input, 0 ,1) eq '#' ) {
			## messaggio di gioco:
			my $nick = $users{$session_id};
			
			&send_to_room($session_id, $nicks{$nick}->{gameroom}, "$nick>$input" );
			
			## Ok, oggi, 15 ott 2006, non capisco che cazzo ho scritto qua, sar che non ci metto
			## mano da un anno... devo assolutamente metterlo online sto gioco!
			## cmq... la sintassi : #<comando> <parametri> e non #<gameroom> <comando>
			## l'utente  in questa stanza ed  una gameroom(!0):
			##if ( (defined $nicks{$nick}->{canali}->{$1}) && ( $nicks{$nick}->{canali}->{$1} != 0 ) ) {
			#	&send_to_room($session_id, $nicks{$nick}->{gameroom}, "$nick>$input" );
			#}
		}
		elsif ( $input =~ m#^\$([\S]+)[\s]{1,1}(.+)# ) {
			## messaggio di chat:
			my $nick = $users{$session_id};

			## l'utente  in questa stanza ed  una chatroom(0):
			if ( (defined $nicks{$nick}->{canali}->{$1}) && ( $nicks{$nick}->{canali}->{$1} == 0 ) ) {
				&send_to_room($session_id, $1, "$nick>$input" );
			}
		}
		else {
			## messaggio non valido: (non fai niente)

		}
        }

    }
}


__END__

=head1 NAME

flashServe - short discription of your program

=head1 SYNOPSIS

 how to us your program

=head1 DESCRIPTION

 long description of your program

=head1 SEE ALSO

 need to know things before somebody uses your program

=head1 AUTHOR

 Debian User,,,

=cut
